/****************************************************************/
/* FILENAME: ADS786x.c                            		*/
/* DESCRIPTION: This program uses the TMS470R1BM to read 500 	*/
/*    samples from the ADS7866/67/68EVM.                        */
/*    The samples are displayed in a watch window.              */
/*    AUTHOR: T. Hendrick, Data Acquisition Products,           */
/*            Dallas Texas                                      */
/*    CREATED 2006(C) BY TEXAS INSTRUMENTS INCORPORATED.  	*/
/*    VERSION: A for SLAA312     				*/
/****************************************************************/
#include <stdio.h>
#include <string.h>
#include <intrinsic.h>
#include "iotms470r1b1m.h"
#include "tms470r1b1m_bit_definitions.h"

// Function Prototypes
void init_spi     (void);
int ADS786x    (void);

/************************************************************************/
/*                                                                      */
/* init_SPI()                                                           */
/*                                                                      */
/************************************************************************/
void init_spi()
{
// Setup the SPI Ports.
// char len = 16; SCLK = 3.4MHz
  SPI1CTRL1=0x1F0;
  SPI2CTRL1=0x1F0;

// SPI1/2CTRL2 internal clock, master mode, CPOL=1, CPHA=0
  SPI1CTRL2 = 0x2A;
  SPI2CTRL2 = 0x2A;

// SPI1/2PC1 and SPIENA perform GPIO functions
  SPI1PC1=0x10;
  SPI2PC1=0x10;

// SPI1/2PC6, SOMI, SIMO and SCLK perform SPI functions
  SPI1PC6=0x1E;
  SPI2PC6=0x1E;

// Enable SPI1/2
 SPI1CTRL2 |= 0x10;
 SPI2CTRL2 |= 0x10;

// Optional ADC Chip Select (I2C2SCL Pin as GPIO)
  I2C2PFNC = 0x01;  // Optional /CS configuration
  I2C2PDIR = 0x03;
}
// Start "forever" conversion loop
int ADS786x()
  {
  int result=0;
      //  This code operates on an ADC EVM positioned in Serial Site 1.  To use
      //   Serial Site 2, simply change the SPI1 calls below to SPI2
      SPI1DAT1 = (0x0000);
      while ((RX_INT_FLAG & SPI1CTRL3) == 0);
      result = (SPI1BUF&0x1FFE);
      return result;

  }
			      	

/************************************************************/
/* Prototype - delay                                        */
/*  Description                                             */
/*  This prototype gives a delay                            */
/************************************************************/

void delay(int time)
      {
      unsigned int i;
      for (i = 0; i < time; i++);
      }
